From ef67e7f6ce48681c3653827b24262098f542971d Mon Sep 17 00:00:00 2001
From: Jiri Gaisler <jiri@gaisler.se>
Date: Wed, 23 Dec 2015 16:17:10 -0500
Subject: [PATCH 01/11] sim/erc32: Use gdb callback for UART I/O when linked
 with gdb.

	* erc32.c (<errno.h>): new include.
	(init_stdio, restore_stdio): don't set tty attributes if ttys not open.
	(DO_STDIO_READ, port_init, read_uart, write_uart, flush_uart, uarta_tx,
	uartb_tx, uart_rx): Use gdb callbacks for console I/O, fix whitespace.

	* func.c (dumbio, tty_setup): new variables.
	(nouartrx): new variable, set to 1 if UART receiver should be disabled.
	(sim_callback): new variable, pointer to gdb host callback structure.

	* interf.c (dumbio): remove duplicate extern declaration.
	(sim_callback): moved to func.c.
	(sim_open): add -nouartrx switch to disable UART input.

	* sis.c (main): Add -nouartrx switch to disable UART input.

	* sis.h (nouartrx, sim_callback, dumbio, tty_setup): add external declare.
---
 sim/erc32/erc32.c  | 161 +++++++++++++++++++++++++++++++++++------------------
 sim/erc32/func.c   |   8 +++
 sim/erc32/interf.c |   6 +-
 sim/erc32/sis.c    |   2 +
 sim/erc32/sis.h    |   5 ++
 5 files changed, 124 insertions(+), 58 deletions(-)

diff --git a/sim/erc32/erc32.c b/sim/erc32/erc32.c
index d722508..c6bf9f8 100644
--- a/sim/erc32/erc32.c
+++ b/sim/erc32/erc32.c
@@ -19,6 +19,7 @@
 /* The control space devices */
 
 #include "config.h"
+#include <errno.h>
 #include <sys/types.h>
 #include <stdio.h>
 #include <string.h>
@@ -35,8 +36,6 @@ extern int32    sparclite, sparclite_board;
 extern int      rom8,wrp,uben;
 extern char     uart_dev1[], uart_dev2[];
 
-int dumbio = 0; /* normal, smart, terminal oriented IO by default */
-
 /* MEC registers */
 #define MEC_START 	0x01f80000
 #define MEC_END 	0x01f80100
@@ -293,7 +292,6 @@ static void	store_bytes (unsigned char *mem, uint32 waddr,
 
 extern int	ext_irl;
 
-
 /* One-time init */
 
 void
@@ -935,44 +933,49 @@ void
 init_stdio()
 {
     if (dumbio)
-        return; /* do nothing */
-    if (!ifd1)
+	return; /* do nothing */
+    if (ifd1 == 0 && f1open) {
 	tcsetattr(0, TCSANOW, &ioc1);
-    if (!ifd2)
+	tcflush (ifd1, TCIFLUSH);
+    }
+    if (ifd2 == 0 && f1open) {
 	tcsetattr(0, TCSANOW, &ioc2);
+	tcflush (ifd2, TCIFLUSH);
+    }
 }
 
 void
 restore_stdio()
 {
     if (dumbio)
-        return; /* do nothing */
-    if (!ifd1)
+	return; /* do nothing */
+    if (ifd1 == 0 && f1open && tty_setup)
 	tcsetattr(0, TCSANOW, &iocold1);
-    if (!ifd2)
+    if (ifd2 == 0 && f2open && tty_setup)
 	tcsetattr(0, TCSANOW, &iocold2);
 }
 
 #define DO_STDIO_READ( _fd_, _buf_, _len_ )          \
-             ( dumbio                                \
-               ? (0) /* no bytes read, no delay */   \
-               : read( _fd_, _buf_, _len_ ) )
-
+	( dumbio || nouartrx \
+	? (0) /* no bytes read, no delay */   \
+	: (_fd_) == 1 && sim_callback ? \
+	sim_callback->read_stdin (sim_callback, _buf_, _len_) :  \
+	read( _fd_, _buf_, _len_ ) )
 
 static void
 port_init()
 {
 
     if (uben) {
-    f2in = stdin;
-    f1in = NULL;
-    f2out = stdout;
-    f1out = NULL;
+	f2in = stdin;
+	f1in = NULL;
+	f2out = stdout;
+	f1out = NULL;
     } else {
-    f1in = stdin;
-    f2in = NULL;
-    f1out = stdout;
-    f2out = NULL;
+	f1in = stdin;
+	f2in = NULL;
+	f1out = stdout;
+	f2out = NULL;
     }
     if (uart_dev1[0] != 0)
 	if ((fd1 = open(uart_dev1, O_RDWR | O_NONBLOCK)) < 0) {
@@ -984,23 +987,29 @@ port_init()
 	    setbuf(f1out, NULL);
 	    f1open = 1;
 	}
-    if (f1in) ifd1 = fileno(f1in);
+    if (f1in)
+	ifd1 = fileno(f1in);
     if (ifd1 == 0) {
+        if (sim_callback && !sim_callback->isatty (sim_callback, ifd1))
+	    tty_setup = 0;
 	if (sis_verbose)
 	    printf("serial port A on stdin/stdout\n");
         if (!dumbio) {
-            tcgetattr(ifd1, &ioc1);
-            iocold1 = ioc1;
-            ioc1.c_lflag &= ~(ICANON | ECHO);
-            ioc1.c_cc[VMIN] = 0;
-            ioc1.c_cc[VTIME] = 0;
+	    tcgetattr (ifd1, &ioc1);
+	    if (tty_setup) {
+		iocold1 = ioc1;
+		ioc1.c_lflag &= ~(ICANON | ECHO);
+		ioc1.c_cc[VMIN] = 0;
+		ioc1.c_cc[VTIME] = 0;
+	    }
         }
 	f1open = 1;
     }
 
     if (f1out) {
 	ofd1 = fileno(f1out);
-    	if (!dumbio && ofd1 == 1) setbuf(f1out, NULL);
+	if (!dumbio && tty_setup && ofd1 == 1)
+	    setbuf (f1out, NULL);
     }
 
     if (uart_dev2[0] != 0)
@@ -1019,17 +1028,20 @@ port_init()
 	    printf("serial port B on stdin/stdout\n");
         if (!dumbio) {
             tcgetattr(ifd2, &ioc2);
-            iocold2 = ioc2;
-            ioc2.c_lflag &= ~(ICANON | ECHO);
-            ioc2.c_cc[VMIN] = 0;
-            ioc2.c_cc[VTIME] = 0;
+            if (tty_setup) {
+		iocold2 = ioc2;
+		ioc2.c_lflag &= ~(ICANON | ECHO);
+		ioc2.c_cc[VMIN] = 0;
+		ioc2.c_cc[VTIME] = 0;
+	    }
         }
 	f2open = 1;
     }
 
     if (f2out) {
 	ofd2 = fileno(f2out);
-        if (!dumbio && ofd2 == 1) setbuf(f2out, NULL);
+	if (!dumbio && tty_setup && ofd2 == 1)
+	    setbuf (f2out, NULL);
     }
 
     wnuma = wnumb = 0;
@@ -1055,9 +1067,10 @@ read_uart(addr)
 		mec_irq(4);
 	    return (0x700 | (uint32) aq[aind++]);
 	} else {
-	    if (f1open) {
-	        anum = DO_STDIO_READ(ifd1, aq, UARTBUF);
-	    }
+	    if (f1open)
+		anum = DO_STDIO_READ(ifd1, aq, UARTBUF);
+	    else
+		anum = 0;
 	    if (anum > 0) {
 		aind = 0;
 		if ((aind + 1) < anum)
@@ -1087,9 +1100,10 @@ read_uart(addr)
 		mec_irq(5);
 	    return (0x700 | (uint32) bq[bind++]);
 	} else {
-	    if (f2open) {
+	    if (f2open)
 		bnum = DO_STDIO_READ(ifd2, bq, UARTBUF);
-	    }
+	    else
+		bnum = 0;
 	    if (bnum > 0) {
 		bind = 0;
 		if ((bind + 1) < bnum)
@@ -1119,9 +1133,10 @@ read_uart(addr)
 	if (aind < anum) {
 	    Ucontrol |= 0x00000001;
 	} else {
-	    if (f1open) {
-	        anum = DO_STDIO_READ(ifd1, aq, UARTBUF);
-            }
+	    if (f1open)
+		anum = DO_STDIO_READ(ifd1, aq, UARTBUF);
+	    else
+		anum = 0;
 	    if (anum > 0) {
 		Ucontrol |= 0x00000001;
 		aind = 0;
@@ -1131,9 +1146,10 @@ read_uart(addr)
 	if (bind < bnum) {
 	    Ucontrol |= 0x00010000;
 	} else {
-	    if (f2open) {
+	    if (f2open)
 		bnum = DO_STDIO_READ(ifd2, bq, UARTBUF);
-	    }
+	    else
+		bnum = 0;
 	    if (bnum > 0) {
 		Ucontrol |= 0x00010000;
 		bind = 0;
@@ -1174,9 +1190,13 @@ write_uart(addr, data)
 	    if (wnuma < UARTBUF)
 	        wbufa[wnuma++] = c;
 	    else {
-	        while (wnuma)
-		    wnuma -= fwrite(wbufa, 1, wnuma, f1out);
-	        wbufa[wnuma++] = c;
+	        while (wnuma) {
+		    if (ofd1 == 1 && sim_callback)
+			wnuma -= sim_callback->write_stdout (sim_callback, wbufa, wnuma);
+		    else
+			wnuma -= fwrite (wbufa, 1, wnuma, f1out);
+		}
+		wbufa[wnuma++] = c;
 	    }
 	}
 	mec_irq(4);
@@ -1198,8 +1218,12 @@ write_uart(addr, data)
 	    if (wnumb < UARTBUF)
 		wbufb[wnumb++] = c;
 	    else {
-		while (wnumb)
-		    wnumb -= fwrite(wbufb, 1, wnumb, f2out);
+		while (wnumb) {
+		    if (ofd1 == 1 && sim_callback)
+			wnumb -= sim_callback->write_stdout (sim_callback, wbufb, wnumb);
+		    else
+			wnumb -= fwrite (wbufb, 1, wnumb, f2out);
+		}
 		wbufb[wnumb++] = c;
 	    }
 	}
@@ -1237,10 +1261,20 @@ write_uart(addr, data)
 static void
 flush_uart()
 {
-    while (wnuma && f1open)
-	wnuma -= fwrite(wbufa, 1, wnuma, f1out);
-    while (wnumb && f2open)
-	wnumb -= fwrite(wbufb, 1, wnumb, f2out);
+    while (wnuma && f1open) {
+	if (ofd1 == 1 && sim_callback) {
+	    wnuma -= sim_callback->write_stdout (sim_callback, wbufa, wnuma);
+	    sim_callback->flush_stdout (sim_callback);
+	} else
+	    wnuma -= fwrite (wbufa, 1, wnuma, f1out);
+    }
+    while (wnumb && f2open) {
+	if (ofd2 == 1 && sim_callback) {
+	    wnuma -= sim_callback->write_stdout (sim_callback, wbufb, wnuma);
+	    sim_callback->flush_stdout (sim_callback);
+	} else
+	wnumb -= fwrite (wbufb, 1, wnumb, f2out);
+    }
 }
 
 
@@ -1248,8 +1282,14 @@ flush_uart()
 static void
 uarta_tx()
 {
-
-    while (f1open && fwrite(&uarta_sreg, 1, 1, f1out) != 1);
+    while (f1open) {
+	if (ofd1 == 1 && sim_callback)
+	    while (sim_callback->write_stdout (sim_callback, &uarta_sreg, 1) != 1)
+		continue;
+	else
+	    while (fwrite (&uarta_sreg, 1, 1, f1out) != 1)
+		continue;
+    }
     if (uart_stat_reg & UARTA_HRE) {
 	uart_stat_reg |= UARTA_SRE;
     } else {
@@ -1263,7 +1303,14 @@ uarta_tx()
 static void
 uartb_tx()
 {
-    while (f2open && fwrite(&uartb_sreg, 1, 1, f2out) != 1);
+    while (f2open) {
+	if (ofd2 == 1 && sim_callback)
+	    while (sim_callback->write_stdout (sim_callback, &uarta_sreg, 1) != 1)
+		continue;
+	else
+	    while (fwrite(&uartb_sreg, 1, 1, f2out) != 1)
+		continue;
+    }
     if (uart_stat_reg & UARTB_HRE) {
 	uart_stat_reg |= UARTB_SRE;
     } else {
@@ -1285,6 +1332,8 @@ uart_rx(arg)
     rsize = 0;
     if (f1open)
         rsize = DO_STDIO_READ(ifd1, &rxd, 1);
+    else
+        rsize = 0;
     if (rsize > 0) {
 	uarta_data = UART_DR | rxd;
 	if (uart_stat_reg & UARTA_HRE)
@@ -1301,6 +1350,8 @@ uart_rx(arg)
     rsize = 0;
     if (f2open)
         rsize = DO_STDIO_READ(ifd2, &rxd, 1);
+    else
+        rsize = 0;
     if (rsize) {
 	uartb_data = UART_DR | rxd;
 	if (uart_stat_reg & UARTB_HRE)
diff --git a/sim/erc32/func.c b/sim/erc32/func.c
index 5d3b9b9..63a6596 100644
--- a/sim/erc32/func.c
+++ b/sim/erc32/func.c
@@ -29,6 +29,12 @@
 
 #define	VAL(x)	strtoul(x,(char **)NULL,0)
 
+/* set if UART device cannot handle attributes, terminal oriented IO by default */
+int dumbio = 0;
+
+/* set if UARTs are connected to a tty, enable by default */
+int tty_setup = 1;
+
 struct disassemble_info dinfo;
 struct pstate   sregs;
 extern struct estate ebase;
@@ -47,6 +53,8 @@ char            uart_dev1[128] = "";
 char            uart_dev2[128] = "";
 extern	int	ext_irl;
 uint32		last_load_addr = 0;
+int		nouartrx = 0;
+host_callback 	*sim_callback;
 
 #ifdef ERRINJ
 uint32		errcnt = 0;
diff --git a/sim/erc32/interf.c b/sim/erc32/interf.c
index 45be1b3..0f7d16b 100644
--- a/sim/erc32/interf.c
+++ b/sim/erc32/interf.c
@@ -50,15 +50,12 @@ extern struct evcell evbuf[];
 extern struct irqcell irqarr[];
 extern int      irqpend, ext_irl;
 extern int      sparclite;
-extern int      dumbio;
 extern int      sparclite_board;
 extern int      termsave;
 extern char     uart_dev1[], uart_dev2[];
 
 int             sis_gdb_break = 1;
 
-host_callback *sim_callback;
-
 int
 run_sim(sregs, icount, dis)
     struct pstate  *sregs;
@@ -192,6 +189,9 @@ sim_open (kind, callback, abfd, argv)
             if (strcmp(argv[stat], "-dumbio") == 0) {
 		dumbio = 1;
 	    } else
+            if (strcmp(argv[stat], "-nouartrx") == 0) {
+		nouartrx = 1;
+	    } else
             if (strcmp(argv[stat], "-wrp") == 0) {
                 wrp = 1;
 	    } else
diff --git a/sim/erc32/sis.c b/sim/erc32/sis.c
index b203c23..aea68cf 100644
--- a/sim/erc32/sis.c
+++ b/sim/erc32/sis.c
@@ -199,6 +199,8 @@ main(argc, argv)
 #endif
             } else if (strcmp(argv[stat], "-dumbio") == 0) {
 		dumbio = 1;
+	    } else if (strcmp(argv[stat], "-nouartrx") == 0) {
+		nouartrx = 1;
 	    } else {
 		printf("unknown option %s\n", argv[stat]);
 		usage();
diff --git a/sim/erc32/sis.h b/sim/erc32/sis.h
index b5bb907..dbdb5b2 100644
--- a/sim/erc32/sis.h
+++ b/sim/erc32/sis.h
@@ -200,6 +200,11 @@ extern void	sys_reset (void);
 extern void	sys_halt (void);
 extern int	bfd_load (const char *fname);
 extern double	get_time (void);
+extern int	nouartrx;
+extern		host_callback *sim_callback;
+extern int	dumbio;
+extern int	tty_setup;
+
 
 /* exec.c */
 extern int	dispatch_instruction (struct pstate *sregs);
-- 
2.7.4

